## kdevelop-pg-qt 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(kdevelop-pg-qt VERSION 2.3.0)

find_package(ECM 6.0.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

set(KDE_COMPILERSETTINGS_LEVEL 5.84)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMSetupVersion)
include(ECMDeprecationSettings)

include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CMakePackageConfigHelpers)

set(CMAKECONFIG_INSTALL_DIR ${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop-PG-Qt)
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelop-PG-QtConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfig.cmake"
                              INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(${kdevelop-pg-qt_VERSION_MAJOR}.${kdevelop-pg-qt_VERSION_MINOR}.${kdevelop-pg-qt_VERSION_PATCH}
                  VARIABLE_PREFIX KDEVELOP_PG_QT
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop-pg-qt_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfigVersion.cmake"
                  SOVERSION ${KDEVELOP_PG_QT_LIB_SOVERSION}
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop-pg-qt_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop-pg-qt")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfigVersion.cmake"
        "${CMAKE_CURRENT_SOURCE_DIR}/KDevelop-PG-QtMacros.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )

if(BUILD_TESTING)
  set(REQUIRED_QT_TESTCOMPONENTS Test)
endif()

set(REQUIRED_QT_VERSION "6.5.0")
find_package(Qt6 ${REQUIRED_QT_VERSION} REQUIRED
  COMPONENTS
    Core
    ${REQUIRED_QT_TESTCOMPONENTS}
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

find_package(FLEX)
set_package_properties(FLEX PROPERTIES
    TYPE RECOMMENDED
)

find_package(BISON)
set_package_properties(BISON PROPERTIES
    TYPE RECOMMENDED
)

ecm_set_disabled_deprecation_versions(
    QT 5.15.2
)

add_definitions(
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_STRICT_ITERATORS
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_NO_CAST_TO_ASCII
)

# Silence a few warnings
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers -Wno-unused-local-typedefs")
endif()

add_subdirectory(include)
add_subdirectory(kdev-pg)
add_subdirectory(examples EXCLUDE_FROM_ALL)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
add_subdirectory(cc)
add_subdirectory(cool)
#add_subdirectory(fact)
add_subdirectory(foolisp)
add_subdirectory(php)

=== kdev-pg/CMakeLists.txt ===
remove_definitions(-DQT_NO_STL)
add_definitions(-DQT_STL)

# tell CMake to generate the executable
add_executable(kdev-pg-qt)
ecm_mark_nongui_executable(kdev-pg-qt)

kde_enable_exceptions()

target_sources(kdev-pg-qt PRIVATE
    ../unidata.qrc
    ASBeautifier.cpp
    ASFormatter.cpp
    ASResource.cpp
    ASEnhancer.cpp
    kdev-pg.cpp
    kdev-pg-visitor.cpp
    kdev-pg-default-visitor.cpp
    kdev-pg-pretty-printer.cpp
    kdev-pg-global.cpp
    kdev-pg-code-gen.cpp
    kdev-pg-ast-gen.cpp
    kdev-pg-visitor-gen.cpp
    kdev-pg-visitor-bits-gen.cpp
    kdev-pg-default-visitor-gen.cpp
    kdev-pg-default-visitor-bits-gen.cpp
    kdev-pg-serialize-visitor-gen.cpp
    kdev-pg-debug-visitor-gen.cpp
    kdev-pg-new-visitor-gen.cpp
    kdev-pg-new-visitor-bits-gen.cpp
    kdev-pg-token-type-gen.cpp
    kdev-pg-beautifier.cpp
    kdev-pg-checker.cpp
    kdev-pg-inline-checker.cpp
    kdev-pg-main.cpp
    kdev-pg-generate.cpp
    kdev-pg-first.cpp
    kdev-pg-follow.cpp
    kdev-pg-bnf-visitor.cpp
    kdev-pg-clone-tree.cpp
    kdev-pg-regexp.cpp
    kdev-pg-unicode-loader.cpp)


# Custom support for flex/bison
if(BISON_EXECUTABLE)
    # Add command to run the parser.
    add_custom_command(
        OUTPUT  "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.cc"
                "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.hh"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-parser.yy"
        COMMAND ${BISON_EXECUTABLE}
        ARGS    -o "kdev-pg-parser.cc"
                -d "${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-parser.yy"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        )

    set(parser_src ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.cc)
    set_source_files_properties(
        ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.cc
        ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.hh
        PROPERTIES
            GENERATED TRUE
            SKIP_AUTOMOC ON
        )
    set(OPTIONAL_PARSER_HEADER_DEPENDENCY "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.hh")
else()
    message("'bison' was not found!")
    message("Assuming existence of the generated parser files kdev-pg-parser.[hh,cc]")
    set(parser_src ${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-parser.cc)
    set(OPTIONAL_PARSER_HEADER_DEPENDENCY "")
endif()

if(FLEX_EXECUTABLE)
    # Add command to run the lexer.
    add_custom_command(
        OUTPUT  "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-lexer.cc"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-lexer.ll"
                 ${OPTIONAL_PARSER_HEADER_DEPENDENCY}
        COMMAND ${FLEX_EXECUTABLE}
        ARGS    --yymore --nounistd -o "kdev-pg-lexer.cc"
                "${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-lexer.ll"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        )

    set(lexer_src ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-lexer.cc)
    set_source_files_properties(
        ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-lexer.cc
        PROPERTIES
            GENERATED TRUE
            SKIP_AUTOMOC ON
        )
else()
    message("'flex' was not found!")
    message("Assuming existence of the generated lexer file kdev-pg-lexer.cc")
    set(lexer_src ${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-lexer.cc)
endif()
set_source_files_properties(${lexer_src} PROPERTIES COMPILE_FLAGS "-DYY_NO_INPUT -DYY_NO_UNPUT")

target_link_libraries( kdev-pg-qt Qt6::Core)
install(TARGETS kdev-pg-qt DESTINATION ${KDE_INSTALL_BINDIR} )

# in order to generate only the parser, call "make parser"
add_custom_target(parser echo "Generating the parser"
    DEPENDS ${parser_src} ${lexer_src}
    )

target_sources(kdev-pg-qt PRIVATE
    ${parser_src}
    ${lexer_src}
)

=== tests/CMakeLists.txt ===
ecm_add_test(testlocationtable.cpp LINK_LIBRARIES Qt6::Core Qt6::Test)
ecm_add_test(testmemorypool.cpp LINK_LIBRARIES Qt6::Core Qt6::Test)
ecm_add_test(benchmarks.cpp LINK_LIBRARIES Qt6::Core Qt6::Test)

=== examples/cc/CMakeLists.txt ===
# add definitions, compiler switches, etc.
add_definitions(-DQT_NO_STL)
add_definitions(-Wall -O2)

# tell CMake to generate the executable
add_executable(cc-parser)

# autogenerate the lexer and the parser
set(KDEVPGQT_EXECUTABLE ${CMAKE_CURRENT_BINARY_DIR}/../../bin/kdev-pg-qt)
set(KDEVPGQT_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/../../../include)
include(${CMAKE_CURRENT_SOURCE_DIR}/../../KDevelop-PG-QtMacros.cmake)
kdevpgqt_generate(cc-parser cc NAMESPACE cc
    "${CMAKE_CURRENT_SOURCE_DIR}/cc.g"
)

if(FLEX_EXECUTABLE)
    # Add command to generate the lexer.
    add_custom_command(
        OUTPUT  "${CMAKE_CURRENT_SOURCE_DIR}/cclexer.cpp"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cc.ll"
                "${CMAKE_CURRENT_SOURCE_DIR}/FlexLexer.h"
                "${CMAKE_CURRENT_BINARY_DIR}/ccparser.h"
        COMMAND ${FLEX_EXECUTABLE}
        ARGS    -o"cclexer.cpp"
                "cc.ll"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

    target_sources(cc-parser PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/cclexer.cpp)

    set_source_files_properties(
        ${CMAKE_CURRENT_SOURCE_DIR}/cclexer.cpp
        PROPERTIES
            GENERATED TRUE
            SKIP_AUTOMOC ON
        )
else()
    message("--- Assuming existence of the generated lexer file cclexer.cpp")
    target_sources(cc-parser PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/cclexer.cpp)
endif()

target_sources(cc-parser PRIVATE
    main.cpp
    dumptree.cpp
)

target_link_libraries( cc-parser Qt6::Core)

=== examples/cool/CMakeLists.txt ===
# add definitions, compiler switches, etc.
remove_definitions(-DQT_NO_STL)
add_definitions(-DQT_STL)
add_definitions(-Wall -O2)

# tell CMake to generate the executable
add_executable(cool-parser)

# autogenerate the lexer and the parser

set(KDEVPGQT_EXECUTABLE ${CMAKE_CURRENT_BINARY_DIR}/../../bin/kdev-pg-qt)
set(KDEVPGQT_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/../../../include)
include(${CMAKE_CURRENT_SOURCE_DIR}/../../KDevelop-PG-QtMacros.cmake)
kdevpgqt_generate(cool-parser cool NAMESPACE cool
    "${CMAKE_CURRENT_SOURCE_DIR}/cool.g"
)


if(FLEX_EXECUTABLE)
    # Add command to generate the lexer.
    add_custom_command(
        OUTPUT  "${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.cpp"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.ll"
                "${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.h"
                "${CMAKE_CURRENT_BINARY_DIR}/coolparser.h"
        COMMAND ${FLEX_EXECUTABLE}
        ARGS    -o"cool_lexer.cpp"
                "cool_lexer.ll"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

    target_sources(cool-parser PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.cpp)

    set_source_files_properties(
        ${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.cpp
        PROPERTIES
            GENERATED TRUE
            SKIP_AUTOMOC ON
        )
else()
    message("--- Assuming existence of the generated lexer file cool_lexer.cpp")
    target_sources(cool-parser PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.cpp)
endif()

target_sources(cool-parser PRIVATE
    main.cpp
    decoder.cpp
    cool_io.cpp
)

target_link_libraries( cool-parser Qt6::Core)

=== examples/fact/CMakeLists.txt ===
find_package(KDevelop-PG-Qt)

# add definitions, compiler switches, etc.
add_definitions(-Wall -O2)

# tell CMake to generate the executable
add_executable(fact-parser)

kdevpgqt_generate(fact-parser fact NAMESPACE fact DEBUG_VISITOR
    "${CMAKE_CURRENT_SOURCE_DIR}/fact.g"
    "${CMAKE_CURRENT_SOURCE_DIR}/factlexer.h"
)

target_sources(fact-parser PRIVATE
    main.cpp
    factlexer.cpp
)

target_link_libraries(fact-parser Qt6::Core)

=== examples/foolisp/CMakeLists.txt ===
add_executable(foolisptest)

target_sources(foolisptest PRIVATE
    foolisptest.cpp
)

set(KDEVPGQT_EXECUTABLE ${CMAKE_CURRENT_BINARY_DIR}/../../bin/kdev-pg-qt)
set(KDEVPGQT_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/../../../include)
include(${CMAKE_CURRENT_SOURCE_DIR}/../../KDevelop-PG-QtMacros.cmake)
kdevpgqt_generate(foolisptest foolisp NAMESPACE FooLisp DEBUG_VISITOR TOKEN_TEXT GENERATE_LEXER
    "${CMAKE_CURRENT_SOURCE_DIR}/foolisp.g"
)

target_link_libraries( foolisptest Qt6::Core)

=== examples/php/CMakeLists.txt ===
add_definitions(-fexceptions)

add_executable(phptest)

target_sources(phptest PRIVATE
    phptest.cpp
)

set(KDEVPGQT_EXECUTABLE ${CMAKE_CURRENT_BINARY_DIR}/../../bin/kdev-pg-qt)

kdevpgqt_generate(phptest php NAMESPACE Php DEBUG_VISITOR TOKEN_TEXT GENERATE_LEXER
    "${CMAKE_CURRENT_SOURCE_DIR}/php.g"
)

target_link_libraries( phptest Qt6::Core)

=== debian/changelog ===
kdevelop-pg-qt (2.3.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update build dependencies from the CMake output.
  * Update Standards-Version to 4.7.0, no changes needed.

 -- Simon Quigley <tsimonq2@debian.org>  Fri, 01 Nov 2024 17:53:24 -0500

=== debian/control ===
Source: kdevelop-pg-qt
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: bison,
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 6.0.0~),
               flex,
               qt6-base-dev (>= 6.5.0~),
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://techbase.kde.org/Development/KDevelop-PG-Qt_Introduction
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdevelop-pg-qt.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdevelop-pg-qt

Package: kdevelop-pg-qt
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: LL(1) parser generator based on Qt
 KDevelop-PG-Qt is a parser generator written in readable source-code and
 generating readable source-code. Its syntax was inspirated by AntLR.
 It implements the visitor-pattern and uses the Qt library.
 .
 This package contains the kdev-pg-qt binary, the headers files generated by
 the KDevelop parser generator and the cmake file to find the parser.

## kdevelop-pg-qt 2.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(kdevelop-pg-qt VERSION 2.4.0)

find_package(ECM 6.0.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMSetupVersion)
include(ECMDeprecationSettings)

include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CMakePackageConfigHelpers)

option(BUILD_EXAMPLES "Build examples" OFF)

option(BUILD_COMPAT_CMAKECONFIG "Build backward compat CMake Config files" ON)

if(BUILD_TESTING)
  set(REQUIRED_QT_TESTCOMPONENTS Test)
endif()

set(REQUIRED_QT_VERSION "6.5.0")
find_package(Qt6 ${REQUIRED_QT_VERSION} REQUIRED
  COMPONENTS
    Core
    ${REQUIRED_QT_TESTCOMPONENTS}
)

find_package(FLEX)
set_package_properties(FLEX PROPERTIES
    TYPE RECOMMENDED
)

find_package(BISON)
set_package_properties(BISON PROPERTIES
    TYPE RECOMMENDED
)

ecm_set_disabled_deprecation_versions(
    QT 6.5
)

# Silence a few warnings
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers -Wno-unused-local-typedefs")
endif()

add_subdirectory(src)

if (BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
include("${CMAKE_SOURCE_DIR}/src/KDevelopPGQtMacros.cmake")

# TODO: fix on windows
if (NOT WIN32)
    add_subdirectory(cc)
    add_subdirectory(cool)
endif()
#add_subdirectory(fact)
add_subdirectory(foolisp)
add_subdirectory(php)

=== src/CMakeLists.txt ===
set(KDEVELOP_PG_QT_INSTALL_INCLUDEDIR "${KDE_INSTALL_INCLUDEDIR}/KDevelopPGQt")

add_subdirectory(include)

# tell CMake to generate the executable
add_executable(kdev-pg-qt)
add_executable(KDevelopPGQt::kdev-pg-qt ALIAS kdev-pg-qt)

ecm_mark_nongui_executable(kdev-pg-qt)

kde_enable_exceptions()

target_include_directories(kdev-pg-qt PRIVATE
    3rdparty/libastyle
)

target_sources(kdev-pg-qt PRIVATE
    unidata.qrc
    3rdparty/libastyle/ASBeautifier.cpp
    3rdparty/libastyle/ASFormatter.cpp
    3rdparty/libastyle/ASResource.cpp
    3rdparty/libastyle/ASEnhancer.cpp
    kdev-pg.cpp
    kdev-pg-visitor.cpp
    kdev-pg-default-visitor.cpp
    kdev-pg-pretty-printer.cpp
    kdev-pg-global.cpp
    kdev-pg-code-gen.cpp
    kdev-pg-ast-gen.cpp
    kdev-pg-visitor-gen.cpp
    kdev-pg-visitor-bits-gen.cpp
    kdev-pg-default-visitor-gen.cpp
    kdev-pg-default-visitor-bits-gen.cpp
    kdev-pg-serialize-visitor-gen.cpp
    kdev-pg-debug-visitor-gen.cpp
    kdev-pg-new-visitor-gen.cpp
    kdev-pg-new-visitor-bits-gen.cpp
    kdev-pg-token-type-gen.cpp
    kdev-pg-beautifier.cpp
    kdev-pg-checker.cpp
    kdev-pg-inline-checker.cpp
    kdev-pg-main.cpp
    kdev-pg-generate.cpp
    kdev-pg-first.cpp
    kdev-pg-follow.cpp
    kdev-pg-bnf-visitor.cpp
    kdev-pg-clone-tree.cpp
    kdev-pg-regexp.cpp
    kdev-pg-unicode-loader.cpp)


# Custom support for flex/bison
if (BISON_FOUND)
    bison_target(kdev_pg_parser
        "${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-parser.yy"
        "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.cc"
        DEFINES_FILE "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.hh"
        # line info mostly not helpful, also avoids "warning: style of line directive is a GCC extension"
        COMPILE_FLAGS "--no-lines"
    )

    set(parser_src ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.cc)
    # workaround CMP0100 being OLD with currently min required CMake 3.16. Remove once unneeded.
    set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-parser.hh
        PROPERTIES
            SKIP_AUTOMOC ON
    )
else()
    message("'bison' was not found!")
    message("Assuming existence of the generated parser files kdev-pg-parser.[hh,cc]")
    set(parser_src ${CMAKE_CURRENT_SOURCE_DIR}/generated/kdev-pg-parser.cc)
endif()

if (FLEX_FOUND)
    flex_target(kdev_pg_lexer
        "${CMAKE_CURRENT_SOURCE_DIR}/kdev-pg-lexer.ll"
        "${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-lexer.cc"
        COMPILE_FLAGS "--yymore --nounistd"
    )
    set(lexer_src ${CMAKE_CURRENT_BINARY_DIR}/kdev-pg-lexer.cc)
else()
    message("'flex' was not found!")
    message("Assuming existence of the generated lexer file kdev-pg-lexer.cc")
    set(lexer_src ${CMAKE_CURRENT_SOURCE_DIR}/generated/kdev-pg-lexer.cc)
endif()
set_source_files_properties(${lexer_src} PROPERTIES COMPILE_FLAGS "-DYY_NO_INPUT -DYY_NO_UNPUT")

target_link_libraries(kdev-pg-qt
    KDevelopPGQt::Utils
    Qt6::Core
)
install(TARGETS kdev-pg-qt EXPORT KDevelopPGQtTargets DESTINATION ${KDE_INSTALL_BINDIR} )

# in order to generate only the parser, call "make parser"
add_custom_target(parser echo "Generating the parser"
    DEPENDS ${parser_src} ${lexer_src}
    )

target_sources(kdev-pg-qt PRIVATE
    ${parser_src}
    ${lexer_src}
)

set(CMAKECONFIG_INSTALL_DIR ${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelopPGQt)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KDevelopPGQtConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelopPGQtConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

ecm_setup_version(${kdevelop-pg-qt_VERSION}
    VARIABLE_PREFIX KDEVELOP_PG_QT
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop-pg-qt_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopPGQtConfigVersion.cmake"
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/kdevelop-pg-qt_version.h"
    DESTINATION "${KDEVELOP_PG_QT_INSTALL_INCLUDEDIR}"
)
install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelopPGQtConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelopPGQtConfigVersion.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/KDevelopPGQtMacros.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
)
install(EXPORT KDevelopPGQtTargets
    FILE        KDevelopPGQtTargets.cmake
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    NAMESPACE KDevelopPGQt::
)

# < 2.4 backward compat
if (BUILD_COMPAT_CMAKECONFIG)

set(CMAKECONFIG_COMPAT_INSTALL_DIR ${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop-PG-Qt)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KDevelop-PG-QtConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_COMPAT_INSTALL_DIR}
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfigVersion.cmake"
    VERSION ${kdevelop-pg-qt_VERSION}
    COMPATIBILITY AnyNewerVersion
)
install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KDevelop-PG-QtConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_COMPAT_INSTALL_DIR}"
)

endif()

=== tests/CMakeLists.txt ===
ecm_add_test(testlocationtable.cpp LINK_LIBRARIES KDevelopPGQt::Utils Qt6::Core Qt6::Test)

ecm_add_test(testmemorypool.cpp LINK_LIBRARIES KDevelopPGQt::Utils Qt6::Core Qt6::Test)

ecm_add_test(benchmarks.cpp LINK_LIBRARIES KDevelopPGQt::Utils Qt6::Core Qt6::Test)

=== examples/cc/CMakeLists.txt ===
# add definitions, compiler switches, etc.
add_definitions(-Wall -O2)

# tell CMake to generate the executable
add_executable(cc-parser)

# autogenerate the lexer and the parser
kdeveloppgqt_generate(cc-parser cc NAMESPACE cc
    "${CMAKE_CURRENT_SOURCE_DIR}/cc.g"
)

if (FLEX_FOUND)
    flex_target(cclexer
        "${CMAKE_CURRENT_SOURCE_DIR}/cc.ll"
        "${CMAKE_CURRENT_BINARY_DIR}/cclexer.cpp"
    )

    target_sources(cc-parser PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/cclexer.cpp)
    target_include_directories(cc-parser PRIVATE ${FLEX_INCLUDE_DIRS})
else()
    message("--- Assuming existence of the generated lexer file cclexer.cpp")
    target_sources(cc-parser PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/generated/cclexer.cpp)
    target_include_directories(cc-parser PRIVATE 3rdparty)
endif()

target_sources(cc-parser PRIVATE
    main.cpp
    dumptree.cpp
)

target_link_libraries(cc-parser
    KDevelopPGQt::Utils
    Qt6::Core
)

=== examples/cool/CMakeLists.txt ===
# add definitions, compiler switches, etc.
add_definitions(-Wall -O2)

# tell CMake to generate the executable
add_executable(cool-parser)

# autogenerate the lexer and the parser

kdeveloppgqt_generate(cool-parser cool NAMESPACE cool
    "${CMAKE_CURRENT_SOURCE_DIR}/cool.g"
)

if (FLEX_FOUND)
    flex_target(cool_lexer
        "${CMAKE_CURRENT_SOURCE_DIR}/cool_lexer.ll"
        "${CMAKE_CURRENT_BINARY_DIR}/cool_lexer.cpp"
    )

    target_sources(cool-parser PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/cool_lexer.cpp)
    target_include_directories(cool-parser PRIVATE ${FLEX_INCLUDE_DIRS})
else()
    message("--- Assuming existence of the generated lexer file cool_lexer.cpp")
    target_sources(cool-parser PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/generated/cool_lexer.cpp)
    target_include_directories(cool-parser PRIVATE 3rdparty)
endif()

target_sources(cool-parser PRIVATE
    main.cpp
    decoder.cpp
    cool_io.cpp
)

target_link_libraries(cool-parser
    KDevelopPGQt::Utils
    Qt6::Core
)

=== examples/fact/CMakeLists.txt ===
find_package(KDevelop-PG-Qt)

# add definitions, compiler switches, etc.
add_definitions(-Wall -O2)

# tell CMake to generate the executable
add_executable(fact-parser)

kdeveloppgqt_generate(fact-parser fact NAMESPACE fact DEBUG_VISITOR
    "${CMAKE_CURRENT_SOURCE_DIR}/fact.g"
    "${CMAKE_CURRENT_SOURCE_DIR}/factlexer.h"
)

target_sources(fact-parser PRIVATE
    main.cpp
    factlexer.cpp
)

target_link_libraries(fact-parser
    KDevelopPGQt::Utils
    Qt6::Core
)

=== examples/foolisp/CMakeLists.txt ===
add_executable(foolisptest)

target_sources(foolisptest PRIVATE
    foolisptest.cpp
)

kdeveloppgqt_generate(foolisptest foolisp NAMESPACE FooLisp DEBUG_VISITOR TOKEN_TEXT GENERATE_LEXER
    "${CMAKE_CURRENT_SOURCE_DIR}/foolisp.g"
)

target_link_libraries(foolisptest
    KDevelopPGQt::Utils
    Qt6::Core
)

=== examples/php/CMakeLists.txt ===
add_definitions(-fexceptions)

add_executable(phptest)

target_sources(phptest PRIVATE
    phptest.cpp
)

kdeveloppgqt_generate(phptest php NAMESPACE Php DEBUG_VISITOR TOKEN_TEXT GENERATE_LEXER
    "${CMAKE_CURRENT_SOURCE_DIR}/php.g"
)

target_link_libraries(phptest
    KDevelopPGQt::Utils
    Qt6::Core
)

=== debian/changelog ===
kdevelop-pg-qt (2.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 15 Mar 2025 07:24:25 +0100

kdevelop-pg-qt (2.3.0-2) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 07 Jan 2025 18:59:56 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                extra-cmake-modules (>= 6.0.0~),
                flex,
                qt6-base-dev (>= 6.5.0~),
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://techbase.kde.org/Development/KDevelop-PG-Qt_Introduction
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdevelop-pg-qt.git

=== debian/watch ===
version=4

https://download.kde.org/stable/kdevelop-pg-qt/([\d.]+)/src/kdevelop-pg-qt-([\d.]+)\.tar\.xz

## kdevelop-pg-qt 2.4.0+p24.04+vstable+git20250505.1246

=== debian/changelog ===
kdevelop-pg-qt (2.4.0+p24.04+vstable+git20250505.1246-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 05 May 2025 12:46:09 +0000

kdevelop-pg-qt (2.4.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 14 Mar 2025 08:43:15 +0000

kdevelop-pg-qt (2.3.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 25 Jul 2024 09:51:21 +0000

kdevelop-pg-qt (2.2.2-0neon) jammy; urgency=medium

  [ Pino Toscano ]
  * Backport upstream commit 846f186291ff26ccf320c0c0e85eccf15782ea68 to help
    building in a reproducible way; patch
    upstream_build-generate-flex-bison-outputs-with-relative-file.patch.

  [ Neon CI ]
  * New release

 -- Neon CI <neon@kde.org>  Wed, 11 Jan 2023 13:55:02 +0000

kdevelop-pg-qt (2.1.0-0neon) xenial; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 27 Jul 2017 13:53:30 +0000

kdevelop-pg-qt (2.0-0neon) xenial; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 24 Aug 2016 15:40:40 +0000

=== debian/control ===
Source: kdevelop-pg-qt
Section: devel
Priority: optional
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               flex,
               kf6-extra-cmake-modules,
               pkg-kde-tools-neon,
               qt6-base-dev
Standards-Version: 4.6.2
Homepage: https://techbase.kde.org/Development/KDevelop-PG-Qt_Introduction
Vcs-Git: https://invent.kde.org/neon/extras/kdevelop-pg-qt.git
Vcs-Browser: https://invent.kde.org/neon/extras/kdevelop-pg-qt
Maintainer: Neon CI <neon@kde.org>

Package: kdevelop-pg-qt
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: LL(1) parser generator based on Qt
 KDevelop-PG-Qt is a parser generator written in readable source-code and
 generating readable source-code. Its syntax was inspirated by AntLR.
 It implements the visitor-pattern and uses the Qt library.
 .
 This package contains the kdev-pg-qt binary, the headers files generated by
 the KDevelop parser generator and the cmake file to find the parser.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ http://download.kde.org/stable/kdevelop-pg-qt/([\d.]+)/src/kdevelop-pg-qt-([\d.]+)\.tar\.xz
